/*
 * lxdash-l.c.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxdash_c_logique(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data, *dxdash_text;
    void *subtext;

    dxdash_data = I_LINE(input[0]);
    dxdash_text = I_LINE(input[1]);

    subtext = context;

    if (dxdash_data == dxdash_text) {
	status = 0;
    } else {
	void *dxtext;

	status = _libx1f4i0_lxdash_line_line(subtext, &dxtext);
	if (status) {
	} else {
	    status = _libx1f4i0_lxdash_late_line
		(subtext, dxdash_data, dxtext, dxdash_text);
	    if (status) {
	    } else {
		status = _libx1f4i0_lxdash_spin_line
		    (subtext, dxtext, dxdash_data);
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxdash_flat_line(subtext, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxdash_stat_line
			(subtext, status, excess);
		}
	    }
	}
    }

    return status;
}
