/*
 * lxline-g.p.c
 * Copyright (C) 2008-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxdata.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

#define lxline(line) \
    ((struct lxline_type *) (line))

int
_libx1f4i0_lxline_p_generic(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct x1f4_dxdata_type *dxdata_data;

    dxline_data = I_LINE(input[0]);

    dxdata_data = I_DATA(input[1]);

    if (0) {
    } else {
	const char *lift;
	unsigned size;
	void *data;

	status = _libx1f4i0_fgxq_sfnote
	    (dxline_data->line, dxdata_data->string, &data, &lift, &size);
	if (status) {
	    status = x1f4_kate_lxdata
		(lxline(context)->link_l.data, dxdata_data, 1, size);
	    if (status) {
	    } else {
		l_MODE(1, output);

		memcpy(dxdata_data->string, lift, size);
	    }
	} else {
	    if (0) {
	    } else {
		l_MODE(0, output);
		if (1) {
		    status = 0;
		}
	    }
	}
    }

    return status;
}
