/*
 * e4-inter.h
 * Copyright (C) 2006-2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_e4_INTER_H__
#define __LIBx1f4_e4_INTER_H__

#include <e4-types.h>

extern int _x1f4_e4_080704_error_0
    (struct e4_back_type *, const char *, unsigned);
extern int _x1f4_e4_080704_error_1
    (struct e4_back_type *, const char *, unsigned);
extern int _x1f4_e4_080704_error_2
    (struct e4_back_type *, const char *, unsigned);
extern int _x1f4_e4_080704_error_3(struct e4_back_type *, const char *);
extern int _x1f4_e4_080704_error_4(struct e4_back_type *);
extern int _x1f4_e4_080704_error_5(struct e4_back_type *);
extern int _x1f4_e4_080704_error_6
    (struct e4_back_type *, const char *, unsigned, int, int);
extern int _x1f4_e4_080704_error_7
    (struct e4_back_type *, struct e4_atom_type *, const char *);
extern int _x1f4_e4_080704_error_8
    (struct e4_back_type *, const char *, unsigned);
extern int _x1f4_e4_080704_error_9
    (struct e4_back_type *, const char *, unsigned);
extern int _x1f4_e4_080704_error_a(struct e4_back_type *);
extern int _x1f4_e4_080704_error_b(struct e4_back_type *);
extern int _x1f4_e4_080704_error_c
    (struct e4_back_type *, struct e4_hack_type *, const char *);
extern int _x1f4_e4_080704_error_d(struct e4_back_type *);
extern int _x1f4_e4_080704_error_e(struct e4_back_type *);
extern int _x1f4_e4_080704_error_f(struct e4_back_type *);
extern int _x1f4_e4_080704_error_g(struct e4_back_type *);
extern int _x1f4_e4_080704_error_h(struct e4_back_type *);
extern int _x1f4_e4_080704_error_i(struct e4_back_type *);
extern int _x1f4_e4_080704_error_j(struct e4_back_type *);
extern int _x1f4_e4_080704_error_k
    (struct e4_back_type *, const void *, unsigned, int, int, const char *);
extern int _x1f4_e4_081014_error_0
    (struct e4_back_type *, const void *, unsigned, const char *);
extern int _x1f4_e4_081014_error_1
    (struct e4_back_type *, struct e4_hack_type *, const void *, unsigned, int,
     int, const char *);
extern int _x1f4_e4_081014_error_2
    (struct e4_back_type *, struct e4_hack_type *, const void *, unsigned,
     const char *);
extern int _x1f4_e4_081019_error_0(struct e4_back_type *);
extern int _x1f4_e4_110605_error_0
    (struct e4_back_type *, const void *, const char *);
extern int _x1f4_e4_110605_error_1
    (struct e4_back_type *, const void *, const char *);
extern int _x1f4_e4_110608_error_1(void *, const char *);
extern int _x1f4_e4_110608_error_2(void *, const char *);
extern int _x1f4_e4_110608_error_3(struct e4_back_type *);
extern int _x1f4_e4_110608_error_4(struct e4_back_type *);
extern int _x1f4_e4_110608_error_5(struct e4_back_type *);
extern int _x1f4_e4_110608_error_6(struct e4_back_type *);
extern int _x1f4_e4_110608_error_7(struct e4_back_type *, int);
extern int _x1f4_e4_110608_error_9(struct e4_back_type *);
extern int _x1f4_e4_110817_error_0
    (struct e4_back_type *, const char *, unsigned);
extern int _x1f4_e4_130607_error_0(struct e4_back_type *, int, int);
extern int _x1f4_e4_130704_error_0(struct e4_back_type *);
extern int _x1f4_e4_beta_expression
    (struct e4_expression_type *, unsigned, struct e4_trap_type *);
extern int _x1f4_e4_find_ce_0
    (struct e4_atom_type *, unsigned *, struct e4_odb2_type **);
extern int _x1f4_e4_find_ce_1
    (struct e4_atom_type *, unsigned, const struct e4_odbl_type *,
     struct e4_odb2_type *, struct e4_atom_type **,
     const struct e4_odbl_type **);
extern int _x1f4_e4_find_ce_2
    (const struct e4_odbl_type *, struct e4_odb2_type *,
     const struct e4_odbl_type **);
extern int _x1f4_e4_find_ce_3
    (struct e4_atom_type *, unsigned, const struct e4_odbl_type *,
     struct e4_odb2_type *, struct e4_atom_type **,
     const struct e4_odbl_type **);
extern int _x1f4_e4_find_ce_4(struct e4_atom_type *, unsigned *);
extern int _x1f4_e4_find_ce_5(struct e4_atom_type *, unsigned);
extern int _x1f4_e4_find_ce_6
    (const struct e4_ndbv_type *, const struct e4_odbx_type *,
     const struct e4_ndbl_type **);
extern int _x1f4_e4_find_ce_8
    (const struct e4_ndbl_type *, struct e4_odb2_type *);
extern int _x1f4_e4_free_data(void *, void *);
extern int _x1f4_e4_line_cn_0(x1f4_e4_TRIP_ARGS_0);
extern int _x1f4_e4_line_cn_1(x1f4_e4_TRIP_ARGS_0);
extern int _x1f4_e4_link_data(void *, void **, unsigned);
extern int _x1f4_e4_link_hack(struct e4_hack_type *, int *, void *);
extern int _x1f4_e4_load_BILL(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Bill(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_MODE(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Mode(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_NEXT(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_NODE(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Next(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Node(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_OVER(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Over(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_REAL(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Real(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_TEAL(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_TEXT(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Teal(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Text(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_THIS(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_USER(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_User(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_WILL(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_Will(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_bill(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_clip(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_ever(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_line(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_lock(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_mode(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_pick(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_real(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_slip(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_text(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_load_this(x1f4_e4_LOAD_ARGS_0);
extern int _x1f4_e4_mode_data(void *, void **, unsigned);
extern int _x1f4_e4_side_news(void *, void *);
extern int _x1f4_e4_text_diff(unsigned char *, unsigned char *);
extern int _x1f4_e4_text_this(x1f4_e4_LINK_ARGS_0);
extern int _x1f4_e4_trip_hack(struct e4_hack_type *, void *);

extern int x1f4_copy_expression
    (struct e4_expression_type **, struct e4_expression_type *);
extern int x1f4_dump_type
    (void *, int (*) (void *, const char *, unsigned), int,
     const struct e4_long_type *);
extern int x1f4_fini_expression(struct e4_expression_type **);
extern int x1f4_iNIt_expression
    (struct e4_expression_type **, const char **, unsigned,
     const struct e4_attributes_type *);
extern int x1f4_inIt_expression
    (struct e4_expression_type **, const char **, unsigned,
     const struct e4_attributes_type *);
extern int x1f4_miss_type
    (void *, int (*) (void *, const char *, unsigned), int, unsigned,
     struct e4_long_type *);
extern int x1f4_size_tcstring(const char *, const char **, unsigned *);
extern int x1f4_span_expression
    (struct e4_expression_type *, struct e4_slip_type *, unsigned, int *,
     void *, struct e4_call_type *, void **);
extern int x1f4_vprint_stfunction
    (void *, int (*) (void *, const char *, unsigned), void *,
     int (*) (void *, const char *, unsigned), const struct e4_last_type *,
     const void *, const void *,
     int (*) (const void *, int, const char **, unsigned *));
extern int x1f4_vprint_xtfunction
    (void *, int (*) (void *, const char *, unsigned), void *,
     int (*) (void *, const char *, unsigned), const struct e4_last_type *,
     const struct e4_long_type *);

extern void _x1f4_e4_bcxx_hack
    (struct e4_hack_type *, unsigned, int (**) (x1f4_e4_LOAD_ARGS_0));
extern void _x1f4_e4_bxxx_hack
    (struct e4_hack_type *, unsigned, int (**) (x1f4_e4_LOAD_ARGS_0));
extern void _x1f4_e4_ceil_side(const struct e4_last_type *, unsigned *);
extern void _x1f4_e4_fare_expression(struct e4_expression_type *);
extern void _x1f4_e4_fast_hack(struct e4_hack_type *, unsigned);
extern void _x1f4_e4_fast_miss(struct e4_hack_type *, unsigned);
extern void _x1f4_e4_free_atom(struct e4_atom_type *, void *);
extern void _x1f4_e4_free_hack(struct e4_hack_type *, void *);
extern void _x1f4_e4_free_odbx(struct e4_atom_type *, void *);
extern void _x1f4_e4_link_laSt(struct e4_atom_type *);
extern void _x1f4_e4_link_last(struct e4_atom_type *);
extern void _x1f4_e4_post_bill(x1f4_e4_POST_ARGS_0);
extern void _x1f4_e4_post_mode(x1f4_e4_POST_ARGS_0);
extern void _x1f4_e4_post_real(x1f4_e4_POST_ARGS_0);
extern void _x1f4_e4_post_text(x1f4_e4_POST_ARGS_0);
extern void _x1f4_e4_post_user(x1f4_e4_POST_ARGS_0);
extern void _x1f4_e4_post_void(x1f4_e4_POST_ARGS_0);
extern void _x1f4_e4_rule_list
    (struct e4_atom_type *, unsigned, unsigned *, struct e4_odb2_type **,
     struct e4_atom_type **);
extern void _x1f4_e4_size_expression
    (struct e4_expression_type *, unsigned *, unsigned *);
extern int _x1f4_e4_type_hack(struct e4_hack_type *, int *, void *);

extern void x1f4_copy_tcstring(char **, const char **);
extern void x1f4_llink_operator2s(const struct e4_odbx_type *const **);
extern void x1f4_print_hfunction
    (void *, const struct e4_last_type *, const char *);
extern void x1f4_print_hfunctions
    (void *, const struct e4_last_type *, const char *);
extern void x1f4_print_htfunction
    (void *, const struct e4_last_type *, const char *, const void *,
     int (*) (const void *, int, const char **, unsigned *));
extern void x1f4_print_htfunctions
    (void *, const struct e4_last_type *, const char *, const void *,
     int (*) (const void *, int, const char **, unsigned *));
extern void x1f4_print_hvariables
    (void *, const struct e4_ever_type *, const char *);

#endif				/* __LIBx1f4_e4_INTER_H__ */
