/*
 * lxdash-e.7.c
 * Copyright (C) 2008, 2009, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <lxcall.h>
#include <lxdash-types.h>

#define lxdash(lxdash) \
    ((struct lxdash_type *) (lxdash))

int
_libx1f4i0_lxdash_lead_text(void *lxdash, void **call)
{
    void *text;

    text = *call;

    return _libx1f4i0_lxcall_land_text
	(&lxdash(lxdash)->link_m, &lxdash(lxdash)->link_e, text, strlen(text),
	 call);
}
