/*
 * lxdash-p.g.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_g_pending(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;

    dxdash_data = I_LINE(input[0]);

    if (0) {
    } else {
	struct effect_type effect;
	void *data;

	effect.mode = I_MODE(input[1]);

	status = _libx1f4i0_fgxd_lxfset(dxdash_data->dash, &effect, &data);
	if (status) {
	    l_MODE(((struct effect_type *) data)->mode, input[2]);
	    l_MODE(1, output);
	    if (0) {
	    } else {
		status = 0;
	    }
	} else {
	    if (0) {
	    } else {
		l_MODE(0, output);
		if (1) {
		    status = 0;
		}
	    }
	}
    }

    return status;
}
