/*
 * lxnear-e.r.c
 * Copyright (C) 2010, 2011, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxnear-inter.h>
#include <lxnote.h>

static const struct x1f4_lxnote_type fail_note = {
/* *INDENT-OFF* */
    NULL,
    NULL,
    NULL,
    NULL,
    _libx1f4i0_lxnear_fini_near,
    _libx1f4i0_lxnear_fset_near,
    NULL,
    NULL,
    NULL,
    _libx1f4i0_lxnear_tile_near,
    NULL
/* *INDENT-ON* */
};

int
x1f4_note_lxnear(const struct x1f4_lxnote_type **lxnote)
{
    *lxnote = &fail_note;

    return 0;
}
